#ifndef gNORM_LIST_X_H
#define gNORM_LIST_X_H

#include "glist.h"
////////////////////////////////////////////////////////////
class gDevNode : public gInt {
public:
    gDevNode (t_uint64 aNode=0, int v=-1) ;
    virtual ~gDevNode () ;

    // Public data-member
    t_uint16 mask;
    t_uint64 node;

    // Get methods
    virtual bool IsOk () {
	return c!=-1;
    }

    virtual bool IsDefaultDevNode () {
	return c==-1 && node>0;
    }

    // Set methods
    virtual bool AddMeToList (gList& lResult) ;

private:
    // Operators,empty
    gDevNode (gDevNode& ) ; //empty
    gDevNode& operator= (gDevNode& ) ; //empty
};
////////////////////////////////////////////////////////////
class gNormList : public gList {
public:
    gNormList () ;
    virtual ~gNormList () ;

    // Public data-members
    static int codeSort;

    // Get methods
    virtual gElem* GetCurrentElemPtr () {
	return pCurrent;  // inherited from gList
    }

    virtual gDevNode& GetDefDevNode () {
	return defDevNode;
    }

    virtual gList& DevNodesList () {
	return devNodes;
    }

    virtual gDevNode& DevNode (unsigned idx) ;

    // Set methods
    unsigned Add (char* s) ;
    unsigned Add (char* s, gDevNode& aDevNode) ;

protected:
    gList devNodes;  // The list of names, and here the list of devNodes (device&node)
    gDevNode defDevNode;

    unsigned thisAddNameToList (char* s, int doSort) ;

private:
    // Operators,empty
    gNormList (gNormList& ) ; //empty
    gNormList& operator= (gNormList& ) ; //empty
};
////////////////////////////////////////////////////////////
#endif //gNORM_LIST_X_H

